--
-- Patch DDL de PECHE du 27/09/2013 à exécuter depuis le user GRHUM
--
-- Rem : fichier encodé UTF-8

SET DEFINE OFF;

--
-- Fichier : 1
-- Type : DDL
-- Schema : GRHUM
-- Numero de version : 1.0.0.0
-- Date de publication : 27/09/2013
-- Auteur(s) : Equipe PECHE

-- Licence : CeCILL version 2
--

WHENEVER SQLERROR EXIT SQL.SQLCODE;


-------------------------V20130718.110238__DDL_Creation_tables_workflow.sql-------------------------
--
-- Patch DDL de GRH_PECHE du 23/04/2013 à exécuter depuis le user GRH_PECHE
--
-- Rem : fichier encodé UTF-8 (Idem 2013042304_SQL_GRH_PECHE_V0.2.0.0_DDL.sql)

--
--
-- Fichier : 4/7
-- Type : DDL
-- Schema : GRH_PECHE
-- Numero de version : 0.2.0.0
-- Date de publication : 23/04/2013 
-- Auteur(s) : Cocktail
-- Licence : CeCILL version 2
--
--

--
-- CIRCUIT_VALIDATION
--
CREATE TABLE GRH_PECHE.CIRCUIT_VALIDATION
(
  ID_CIRCUIT_VALIDATION NUMBER	NOT NULL,
  ID_APP NUMBER(12,0) NOT NULL,
  C_CIRCUIT_VALIDATION	VARCHAR2(30) NOT NULL,
  NUMERO_VERSION NUMBER NOT NULL,
  LL_CIRCUIT_VALIDATION	VARCHAR2(100) NOT NULL,
  TEM_UTILISABLE VARCHAR2(1) DEFAULT 'N' NOT NULL,
  D_MODIFICATION DATE DEFAULT SYSDATE NOT NULL,
  PERS_ID_MODIFICATION NUMBER NOT NULL
);

ALTER TABLE GRH_PECHE.CIRCUIT_VALIDATION ADD CONSTRAINT PK_CIRCUIT_VALIDATION PRIMARY KEY(ID_CIRCUIT_VALIDATION) USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.CIRCUIT_VALIDATION ADD CONSTRAINT UK_CIRCUIT_VALIDATION  UNIQUE (ID_APP, C_CIRCUIT_VALIDATION, NUMERO_VERSION);

ALTER TABLE GRH_PECHE.CIRCUIT_VALIDATION ADD CONSTRAINT FK_CIRCUIT_VALID_GD_APPLI FOREIGN KEY (ID_APP) REFERENCES GRHUM.GD_APPLICATION (APP_ID);

ALTER TABLE GRH_PECHE.CIRCUIT_VALIDATION ADD CONSTRAINT CHK_CIRCUIT_TEM_UTILISABLE CHECK (TEM_UTILISABLE IN ('O', 'N'));

CREATE SEQUENCE GRH_PECHE.CIRCUIT_VALIDATION_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRH_PECHE.CIRCUIT_VALIDATION IS 'Table des circuits de validation';    
COMMENT ON COLUMN GRH_PECHE.CIRCUIT_VALIDATION.ID_CIRCUIT_VALIDATION IS 'Clef primaire de la table CIRCUIT_VALIDATION';
COMMENT ON COLUMN GRH_PECHE.CIRCUIT_VALIDATION.ID_APP IS 'Référence à l''application (cf. GRHUM.GD_APPLICATION.APP_ID)';
COMMENT ON COLUMN GRH_PECHE.CIRCUIT_VALIDATION.C_CIRCUIT_VALIDATION IS 'Code du circuit de validation';
COMMENT ON COLUMN GRH_PECHE.CIRCUIT_VALIDATION.NUMERO_VERSION IS 'Numéro de version du circuit';
COMMENT ON COLUMN GRH_PECHE.CIRCUIT_VALIDATION.LL_CIRCUIT_VALIDATION IS 'Libellé long du circuit de validation';
COMMENT ON COLUMN GRH_PECHE.CIRCUIT_VALIDATION.TEM_UTILISABLE IS 'Est-ce que le circuit de validation est utilisable ? (O/N)';
COMMENT ON COLUMN GRH_PECHE.CIRCUIT_VALIDATION.D_MODIFICATION IS 'Date de la derniere modification de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.CIRCUIT_VALIDATION.PERS_ID_MODIFICATION IS 'Pers_id de la personne à l''origine de la modification de l''enregistrement';

--
-- ETAPE
--
CREATE TABLE GRH_PECHE.ETAPE
(
  ID_ETAPE 	 	NUMBER	NOT NULL ,
  C_ETAPE		VARCHAR2(20) NOT NULL,
  LL_ETAPE		VARCHAR2(100) NOT NULL,
  ID_CIRCUIT_VALIDATION	NUMBER NOT NULL,
  TEM_ETAPE_INITIALE VARCHAR2(1) DEFAULT 'N' NOT NULL 
);

ALTER TABLE GRH_PECHE.ETAPE ADD CONSTRAINT PK_ETAPE PRIMARY KEY(ID_ETAPE) USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.ETAPE  ADD CONSTRAINT UK_ETAPE_CODE_CIRCUIT  UNIQUE (C_ETAPE, ID_CIRCUIT_VALIDATION);

ALTER TABLE GRH_PECHE.ETAPE ADD CONSTRAINT FK_ETA_CIRCUIT_VALID FOREIGN KEY (ID_CIRCUIT_VALIDATION) REFERENCES GRH_PECHE.CIRCUIT_VALIDATION (ID_CIRCUIT_VALIDATION);
ALTER TABLE GRH_PECHE.ETAPE ADD CONSTRAINT CHK_ETA_TEM_ETAPE_INI CHECK (TEM_ETAPE_INITIALE IN ('O', 'N') );

CREATE INDEX GRH_PECHE.IDX_ETA_ID_CIRCUIT_VALID ON GRH_PECHE.ETAPE(ID_CIRCUIT_VALIDATION) TABLESPACE GRH_INDX;

CREATE SEQUENCE GRH_PECHE.ETAPE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRH_PECHE.ETAPE IS 'Table des étapes générées(validation, annulation,...)';    
COMMENT ON COLUMN GRH_PECHE.ETAPE.ID_ETAPE IS 'Clef primaire de la table ETAPE';
COMMENT ON COLUMN GRH_PECHE.ETAPE.C_ETAPE IS 'Code de l''étape';
COMMENT ON COLUMN GRH_PECHE.ETAPE.LL_ETAPE IS 'Libellé long de l''étape';
COMMENT ON COLUMN GRH_PECHE.ETAPE.ID_CIRCUIT_VALIDATION IS 'Référence au circuit de validation (cf. GRH_PECHE.CIRCUIT_VALIDATION.ID_CIRCUIT_VALIDATION)';
COMMENT ON COLUMN GRH_PECHE.ETAPE.TEM_ETAPE_INITIALE IS 'Est-ce que c''est l''étape initiale ? (O:valide, N:invalide)';

--
-- DEMANDE
--
CREATE TABLE GRH_PECHE.DEMANDE
(
  ID_DEMANDE NUMBER NOT NULL ,
  ID_ETAPE NUMBER NOT NULL
);

ALTER TABLE GRH_PECHE.DEMANDE ADD CONSTRAINT PK_DEMANDE PRIMARY KEY(ID_DEMANDE) USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.DEMANDE ADD CONSTRAINT FK_DEMANDE_ID_ETAPE FOREIGN KEY (ID_ETAPE) REFERENCES GRH_PECHE.ETAPE (ID_ETAPE);

CREATE INDEX GRH_PECHE.IDX_DEMANDE_ID_ETAPE ON GRH_PECHE.DEMANDE(ID_ETAPE) TABLESPACE GRH_INDX;

CREATE SEQUENCE GRH_PECHE.DEMANDE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRH_PECHE.DEMANDE IS 'Table des demandes en cours';    
COMMENT ON COLUMN GRH_PECHE.DEMANDE.ID_DEMANDE IS 'Clef primaire de la table DEMANDE';
COMMENT ON COLUMN GRH_PECHE.DEMANDE.ID_ETAPE IS 'Référence à l''étape en cours (cf. GRH_PECHE.ETAPE.ID_ETAPE)';

--
-- CHEMIN
--
CREATE TABLE GRH_PECHE.CHEMIN
(
  ID_CHEMIN NUMBER NOT NULL,
  ID_ETAPE_DEPART NUMBER NOT NULL,
  ID_ETAPE_ARRIVEE NUMBER,
  C_TYPE_CHEMIN VARCHAR2(20) NOT NULL,
  LC_TYPE_CHEMIN VARCHAR2(50) NOT NULL
);

ALTER TABLE GRH_PECHE.CHEMIN ADD CONSTRAINT PK_CHEMIN PRIMARY KEY(ID_CHEMIN) USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.CHEMIN ADD CONSTRAINT FK_CHEMIN_ETAPE_DEPART FOREIGN KEY (ID_ETAPE_DEPART) REFERENCES GRH_PECHE.ETAPE (ID_ETAPE);
ALTER TABLE GRH_PECHE.CHEMIN ADD CONSTRAINT FK_CHEMIN_ETAPE_ARRIVEE FOREIGN KEY (ID_ETAPE_ARRIVEE) REFERENCES GRH_PECHE.ETAPE (ID_ETAPE);
ALTER TABLE GRH_PECHE.CHEMIN ADD CONSTRAINT UK_CHEMIN_ETAPE_DEPART_TYP_CHE UNIQUE (ID_ETAPE_DEPART, C_TYPE_CHEMIN);

CREATE INDEX GRH_PECHE.IDX_CHEMIN_ETAPE_DEPART ON GRH_PECHE.CHEMIN(ID_ETAPE_DEPART) TABLESPACE GRH_INDX;
CREATE INDEX GRH_PECHE.IDX_CHEMIN_ETAPE_ARRIVEE ON GRH_PECHE.CHEMIN(ID_ETAPE_ARRIVEE) TABLESPACE GRH_INDX;

CREATE SEQUENCE GRH_PECHE.CHEMIN_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRH_PECHE.CHEMIN IS 'Table des chemins valides';   
COMMENT ON COLUMN GRH_PECHE.CHEMIN.ID_CHEMIN IS 'Clef primaire de la table CHEMIN'; 
COMMENT ON COLUMN GRH_PECHE.CHEMIN.ID_ETAPE_DEPART IS 'Référence à l''étape de départ (cf. GRH_PECHE.ETAPE.ID_ETAPE), peut être à null si étape initiale';
COMMENT ON COLUMN GRH_PECHE.CHEMIN.ID_ETAPE_ARRIVEE IS 'Référence à l''étape d''arrivée (cf. GRH_PECHE.ETAPE.ID_ETAPE)';
COMMENT ON COLUMN GRH_PECHE.CHEMIN.C_TYPE_CHEMIN IS 'Code du type de chemin';
COMMENT ON COLUMN GRH_PECHE.CHEMIN.LC_TYPE_CHEMIN IS 'Libellé court du type de chemin';

--
-- HISTORIQUE_DEMANDE
--
CREATE TABLE GRH_PECHE.HISTORIQUE_DEMANDE
(
  ID_HISTORIQUE_DEMANDE NUMBER NOT NULL ,
  ID_DEMANDE 		NUMBER NOT NULL ,
  ID_ETAPE_DEPART  	NUMBER,
  ID_ETAPE_ARRIVEE   	NUMBER NOT NULL,
  PERS_ID_MODIFICATION 	NUMBER NOT NULL,
  D_MODIFICATION 	DATE DEFAULT SYSDATE NOT NULL
  
);

ALTER TABLE GRH_PECHE.HISTORIQUE_DEMANDE ADD CONSTRAINT PK_HISTORIQUE_DEMANDE PRIMARY KEY(ID_HISTORIQUE_DEMANDE) USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.HISTORIQUE_DEMANDE ADD CONSTRAINT FK_HD_ID_DEMANDE FOREIGN KEY (ID_DEMANDE) REFERENCES GRH_PECHE.DEMANDE (ID_DEMANDE);
ALTER TABLE GRH_PECHE.HISTORIQUE_DEMANDE ADD CONSTRAINT FK_HD_ID_ETAPE_DEPART FOREIGN KEY (ID_ETAPE_DEPART) REFERENCES GRH_PECHE.ETAPE (ID_ETAPE);
ALTER TABLE GRH_PECHE.HISTORIQUE_DEMANDE ADD CONSTRAINT FK_HD_ID_ETAPE_ARRIVEE FOREIGN KEY (ID_ETAPE_ARRIVEE) REFERENCES GRH_PECHE.ETAPE (ID_ETAPE);
ALTER TABLE GRH_PECHE.HISTORIQUE_DEMANDE ADD CONSTRAINT FK_HD_PERS_ID_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);

CREATE INDEX GRH_PECHE.IDX_HD_ID_DEMANDE ON GRH_PECHE.HISTORIQUE_DEMANDE(ID_DEMANDE) TABLESPACE GRH_INDX;
CREATE INDEX GRH_PECHE.IDX_HD_ETAPE_DEPART ON GRH_PECHE.HISTORIQUE_DEMANDE(ID_ETAPE_DEPART) TABLESPACE GRH_INDX;
CREATE INDEX GRH_PECHE.IDX_HD_ETAPE_ARRIVEE ON GRH_PECHE.HISTORIQUE_DEMANDE(ID_ETAPE_ARRIVEE) TABLESPACE GRH_INDX;
CREATE INDEX GRH_PECHE.IDX_HD_PERS_MODIFICATION ON GRH_PECHE.HISTORIQUE_DEMANDE(PERS_ID_MODIFICATION) TABLESPACE GRH_INDX;

CREATE SEQUENCE GRH_PECHE.HISTORIQUE_DEMANDE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRH_PECHE.HISTORIQUE_DEMANDE IS 'Historisation des demandes qui change d''étape'; 
COMMENT ON COLUMN GRH_PECHE.HISTORIQUE_DEMANDE.ID_HISTORIQUE_DEMANDE IS 'Clef primaire de la table HISTORIQUE_DEMANDE';   
COMMENT ON COLUMN GRH_PECHE.HISTORIQUE_DEMANDE.ID_DEMANDE IS 'Référence à la demande historisée (cf. GRH_PECHE.DEMANDE.ID_DEMANDE)';
COMMENT ON COLUMN GRH_PECHE.HISTORIQUE_DEMANDE.ID_ETAPE_DEPART IS 'Référence à l''étape de départ (cf. GRH_PECHE.ETAPE.ID_ETAPE), peut être à null si étape initiale';
COMMENT ON COLUMN GRH_PECHE.HISTORIQUE_DEMANDE.ID_ETAPE_ARRIVEE IS 'Référence à l''étape d''arrivée (cf. GRH_PECHE.ETAPE.ID_ETAPE)';
COMMENT ON COLUMN GRH_PECHE.HISTORIQUE_DEMANDE.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification du statut de la demande';
COMMENT ON COLUMN GRH_PECHE.HISTORIQUE_DEMANDE.D_MODIFICATION IS 'Date de modification de la demande';

--
-- PECHE_PARAMETRES
--
CREATE TABLE GRH_PECHE.PECHE_PARAMETRES
(
  PARAM_ID              NUMBER NOT NULL ,
  PARAM_KEY             VARCHAR2(2000),
  PARAM_VALUE           VARCHAR2(500) ,
  PARAM_COMMENTAIRES    VARCHAR2(500) ,
  D_CREATION            DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION        DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION      NUMBER NOT NULL ,
  PERS_ID_MODIFICATION  NUMBER 
);

ALTER TABLE GRH_PECHE.PECHE_PARAMETRES ADD CONSTRAINT PK_PECHE_PARAMETRES PRIMARY KEY(PARAM_ID) USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.PECHE_PARAMETRES ADD CONSTRAINT FK_PARAM_PERS_ID_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE GRH_PECHE.PECHE_PARAMETRES ADD CONSTRAINT FK_PARAM_PERS_ID_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
  
CREATE INDEX GRH_PECHE.IDX_PARAM_PARAM_KEY ON GRH_PECHE.PECHE_PARAMETRES(PARAM_KEY) TABLESPACE GRH_INDX;

CREATE SEQUENCE GRH_PECHE.PECHE_PARAMETRES_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE  GRH_PECHE.PECHE_PARAMETRES IS 'Les paramètres de l''application PECHE';
COMMENT ON COLUMN GRH_PECHE.PECHE_PARAMETRES.PARAM_ID IS 'Clef primaire de la table PECHE_PARAMETRES.';
COMMENT ON COLUMN GRH_PECHE.PECHE_PARAMETRES.PARAM_KEY IS 'Code du paramètre ';
COMMENT ON COLUMN GRH_PECHE.PECHE_PARAMETRES.PARAM_VALUE IS 'Valeur du paramètre';
COMMENT ON COLUMN GRH_PECHE.PECHE_PARAMETRES.PARAM_COMMENTAIRES IS 'Commentaire du paramètre';
COMMENT ON COLUMN GRH_PECHE.PECHE_PARAMETRES.D_CREATION IS 'Date de création de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.PECHE_PARAMETRES.D_MODIFICATION IS 'Date de la dernière modification de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.PECHE_PARAMETRES.PERS_ID_CREATION IS 'Pers_id de la personne à l''origine de la création de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.PECHE_PARAMETRES.PERS_ID_MODIFICATION IS 'Pers_id de la personne à l''origine de la modification de l''enregistrement.';

--
-- METHODES_CALCUL_HCOMP
--
CREATE TABLE GRH_PECHE.METHODES_CALCUL_HCOMP
(
  METHODE_ID            NUMBER NOT NULL ,
  LL_METHODE            VARCHAR2(100),
  CLASSE_METHODE        VARCHAR2(100) ,
  D_CREATION            DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION        DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION      NUMBER NOT NULL ,
  PERS_ID_MODIFICATION  NUMBER 
);

ALTER TABLE GRH_PECHE.METHODES_CALCUL_HCOMP ADD CONSTRAINT PK_METHODES_CALCUL_HCOMP PRIMARY KEY(METHODE_ID) USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.METHODES_CALCUL_HCOMP ADD CONSTRAINT FK_METHODES_PERS_ID_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE GRH_PECHE.METHODES_CALCUL_HCOMP ADD CONSTRAINT FK_METH_PERS_ID_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
  
CREATE SEQUENCE GRH_PECHE.METHODES_CALCUL_HCOMP_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE  GRH_PECHE.METHODES_CALCUL_HCOMP IS 'Les méthodes de calculs des heures complémentaires';
COMMENT ON COLUMN GRH_PECHE.METHODES_CALCUL_HCOMP.METHODE_ID IS 'Clef primaire de la table METHODES_CALCUL_HCOMP.';
COMMENT ON COLUMN GRH_PECHE.METHODES_CALCUL_HCOMP.LL_METHODE IS 'Le libellé de la méthode de calcul';
COMMENT ON COLUMN GRH_PECHE.METHODES_CALCUL_HCOMP.CLASSE_METHODE IS 'Le nom de la classe Java qui permet de faire le calcul';
COMMENT ON COLUMN GRH_PECHE.METHODES_CALCUL_HCOMP.D_CREATION IS 'Date de création de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.METHODES_CALCUL_HCOMP.D_MODIFICATION IS 'Date de la dernière modification de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.METHODES_CALCUL_HCOMP.PERS_ID_CREATION IS 'Pers_id de la personne à l''origine de la création de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.METHODES_CALCUL_HCOMP.PERS_ID_MODIFICATION IS 'Pers_id de la personne à l''origine de la modification de l''enregistrement.';

--
-- REPART_METHODE_CORPS
--
CREATE TABLE GRH_PECHE.REPART_METHODE_CORPS
(
  METHODE_ID     NUMBER NOT NULL,
  C_CORPS        VARCHAR2(4) NOT NULL,
  D_CREATION     DATE DEFAULT SYSDATE NOT NULL,
  D_MODIFICATION DATE DEFAULT SYSDATE NOT NULL
);

ALTER TABLE GRH_PECHE.REPART_METHODE_CORPS ADD CONSTRAINT PK_REPART_METHODE_CORPS PRIMARY KEY(METHODE_ID, C_CORPS);
ALTER TABLE GRH_PECHE.REPART_METHODE_CORPS ADD CONSTRAINT FK_REPART_METHODE_CORPS_METHO FOREIGN KEY (METHODE_ID) REFERENCES GRH_PECHE.METHODES_CALCUL_HCOMP(METHODE_ID);
ALTER TABLE GRH_PECHE.REPART_METHODE_CORPS ADD CONSTRAINT FK_REPART_METHODE_CORPS_CORPS FOREIGN KEY (C_CORPS) REFERENCES GRHUM.CORPS(C_CORPS);

COMMENT ON TABLE GRH_PECHE.REPART_METHODE_CORPS IS 'Répartition des méthodes de calculs pour les corps des enseignants.';
COMMENT ON COLUMN GRH_PECHE.REPART_METHODE_CORPS.METHODE_ID IS 'Référence la clef primaire de la table GRH_PECHE.METHODES_CALCUL_HCOMP.';
COMMENT ON COLUMN GRH_PECHE.REPART_METHODE_CORPS.METHODE_ID IS 'Référence la clef primaire de la table GRHUM.CORPS.';
COMMENT ON COLUMN GRH_PECHE.REPART_METHODE_CORPS.D_CREATION IS 'Date de création de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.REPART_METHODE_CORPS.D_MODIFICATION IS 'Date de la dernière modification de l''enregistrement.';


-----------------------------V20130718.110252__DDL_Creation_tables.sql------------------------------
--
-- Patch DDL de GRH_PECHE du 23/04/2013 à exécuter depuis le user GRH_PECHE
--
-- Rem : fichier encodé UTF-8 (Idem 2013042305_SQL_GRH_PECHE_V0.2.0.0_DDL.sql)

--
--
-- Fichier : 5/7
-- Type : DDL
-- Schema : GRH_PECHE
-- Numero de version : 0.2.0.0
-- Date de publication : 23/04/2013 
-- Auteur(s) : Cocktail
-- Licence : CeCILL version 2
--
--

--
-- DB_VERSION
--
CREATE TABLE GRH_PECHE.DB_VERSION 
(
  DBV_ID	NUMBER(4) NOT NULL, 
  DBV_LIBELLE	VARCHAR2(15) NOT NULL, 
  DBV_DATE	DATE NOT NULL, 
  DBV_INSTALL	DATE, 
  DBV_COMMENT	VARCHAR2(2000)
);

ALTER TABLE GRH_PECHE.DB_VERSION ADD CONSTRAINT PK_DB_VERSION PRIMARY KEY (DBV_ID) USING INDEX TABLESPACE GRH_INDX;
CREATE SEQUENCE GRH_PECHE.DB_VERSION_SEQ START WITH 1 NOCACHE;

COMMENT ON TABLE GRH_PECHE.DB_VERSION IS 'Historique des versions du schéma du user GRH_PECHE'; 
COMMENT ON COLUMN GRH_PECHE.DB_VERSION.DBV_ID IS 'Identifiant de la version'; 
COMMENT ON COLUMN GRH_PECHE.DB_VERSION.DBV_LIBELLE IS 'Libellé de la version'; 
COMMENT ON COLUMN GRH_PECHE.DB_VERSION.DBV_DATE IS 'Date de release de la version'; 
COMMENT ON COLUMN GRH_PECHE.DB_VERSION.DBV_INSTALL IS 'Date d''installation de la version. Si non renseigné, la version n''est pas complétement installée.';
COMMENT ON COLUMN GRH_PECHE.DB_VERSION.DBV_COMMENT IS 'Le commentaire : une courte description de cette version de la base de données.';


--
--  REH
--
CREATE TABLE GRH_PECHE.REH
(
  ID_REH		NUMBER NOT NULL ,
  LC_REH   		VARCHAR2(128) ,
  LL_REH   		VARCHAR2(256) ,
  DESCRIPTION 		VARCHAR2(2048) ,
  COMMENTAIRE 		VARCHAR2(1024) ,
  D_DEBUT 		DATE DEFAULT SYSDATE NOT NULL,
  D_FIN  		DATE DEFAULT SYSDATE ,
  D_CREATION 		DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION 	DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION  	NUMBER NOT NULL ,
  PERS_ID_MODIFICATION 	NUMBER  
);

ALTER TABLE GRH_PECHE.REH ADD CONSTRAINT PK_REH PRIMARY KEY(ID_REH) USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.REH ADD CONSTRAINT FK_REH_PERSONNE_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE GRH_PECHE.REH ADD CONSTRAINT FK_REH_PERSONNE_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);

CREATE SEQUENCE GRH_PECHE.REH_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRH_PECHE.REH IS 'Table des activités du Réferentiel des Equivalences Horaires';    
COMMENT ON COLUMN GRH_PECHE.REH.ID_REH IS 'Clef primaire de la table REH';
COMMENT ON COLUMN GRH_PECHE.REH.LC_REH IS 'Libellé court de l''activité REH';
COMMENT ON COLUMN GRH_PECHE.REH.LL_REH IS 'Libellé long de l''activité REH';
COMMENT ON COLUMN GRH_PECHE.REH.DESCRIPTION IS 'Description de l''activité REH';
COMMENT ON COLUMN GRH_PECHE.REH.COMMENTAIRE IS 'Commentaire avec les méthodes de calcul de l''activité REH';
COMMENT ON COLUMN GRH_PECHE.REH.D_DEBUT IS 'Date du début de l''activité REH';
COMMENT ON COLUMN GRH_PECHE.REH.D_FIN IS 'Date du fin de l''activité REH';
COMMENT ON COLUMN GRH_PECHE.REH.D_CREATION IS 'Date de création de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.REH.D_MODIFICATION IS 'Date de modification de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.REH.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.REH.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';


--
-- ENSEIGNANT_GENERIQUE
--
CREATE TABLE GRH_PECHE.ENSEIGNANT_GENERIQUE
(
  ID_ENSEIGNANT_GENERIQUE	NUMBER	NOT NULL ,
  NOM		 		VARCHAR2(30) ,
  PRENOM		 	VARCHAR2(30) ,
  C_CORPS 			VARCHAR2(4) ,
  HEURES_PREVUES	 	NUMBER	DEFAULT 0 NOT NULL ,
  TEM_VALIDE 			VARCHAR2(1) DEFAULT 'O' NOT NULL , 
  COMMENTAIRE 			VARCHAR2(1024) ,
  D_COMMENTAIRE  		DATE DEFAULT SYSDATE ,
  D_CREATION 			DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION 		DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION  		NUMBER NOT NULL ,
  PERS_ID_MODIFICATION 		NUMBER 
);


ALTER TABLE GRH_PECHE.ENSEIGNANT_GENERIQUE ADD CONSTRAINT PK_ENSEIGNANT_GENERIQUE PRIMARY KEY(ID_ENSEIGNANT_GENERIQUE) USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.ENSEIGNANT_GENERIQUE ADD CONSTRAINT FK_EG_CORPS FOREIGN KEY (C_CORPS) REFERENCES GRHUM.CORPS (C_CORPS);
ALTER TABLE GRH_PECHE.ENSEIGNANT_GENERIQUE ADD CONSTRAINT FK_EG_PERSONNE_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE GRH_PECHE.ENSEIGNANT_GENERIQUE ADD CONSTRAINT FK_EG_PERSONNE_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE GRH_PECHE.ENSEIGNANT_GENERIQUE ADD CONSTRAINT CHK_EG_TEM_VALIDE CHECK (TEM_VALIDE IN ('O', 'N') );

CREATE INDEX GRH_PECHE.IDX_EG_C_CORPS ON GRH_PECHE.ENSEIGNANT_GENERIQUE(C_CORPS) TABLESPACE GRH_INDX;

CREATE SEQUENCE GRH_PECHE.ENSEIGNANT_GENERIQUE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRH_PECHE.ENSEIGNANT_GENERIQUE IS 'Table qui permet de recenser les intervenants pas encore renseignés dans MANGUE';
COMMENT ON COLUMN GRH_PECHE.ENSEIGNANT_GENERIQUE.ID_ENSEIGNANT_GENERIQUE IS 'Clef primaire de la table ENSEIGNANT_GENERIQUE';
COMMENT ON COLUMN GRH_PECHE.ENSEIGNANT_GENERIQUE.NOM IS 'Nom de l''intervenant si connu';
COMMENT ON COLUMN GRH_PECHE.ENSEIGNANT_GENERIQUE.PRENOM IS 'Prénom de l''intervenant si connu';
COMMENT ON COLUMN GRH_PECHE.ENSEIGNANT_GENERIQUE.C_CORPS IS 'Type de population concernée (cf. GRHUM.CORPS.C_CORPS)';
COMMENT ON COLUMN GRH_PECHE.ENSEIGNANT_GENERIQUE.HEURES_PREVUES IS 'Heures du service prévu pour l''intervenant si c_corps non renseigné';
COMMENT ON COLUMN GRH_PECHE.ENSEIGNANT_GENERIQUE.TEM_VALIDE IS 'Validité de l''enregistrement ? (O:valide, N:invalide) ';
COMMENT ON COLUMN GRH_PECHE.ENSEIGNANT_GENERIQUE.COMMENTAIRE IS 'Commentaire sur l''intervenant';
COMMENT ON COLUMN GRH_PECHE.ENSEIGNANT_GENERIQUE.D_COMMENTAIRE IS 'Date de création du commentaire';
COMMENT ON COLUMN GRH_PECHE.ENSEIGNANT_GENERIQUE.D_CREATION IS 'Date de création de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.ENSEIGNANT_GENERIQUE.D_MODIFICATION IS 'Date de modification de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.ENSEIGNANT_GENERIQUE.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.ENSEIGNANT_GENERIQUE.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';


--
-- SERVICE
--
CREATE TABLE GRH_PECHE.SERVICE
(
  ID_SERVICE			NUMBER	NOT NULL ,
  ID_DEMANDE 			NUMBER ,
  NO_INDIVIDU    		NUMBER(8, 0),
  ID_ENSEIGNANT_GENERIQUE	NUMBER ,
  TEM_ENS_GENERIQUE		VARCHAR2(1) DEFAULT 'N' NOT NULL ,
  TEM_VALIDE			VARCHAR2(1) DEFAULT 'O' NOT NULL ,
  COMMENTAIRE 			VARCHAR2(1024) ,
  D_COMMENTAIRE  		DATE ,
  ANNEE 			NUMBER(4) NOT NULL ,
  D_CREATION 			DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION 		DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION  		NUMBER NOT NULL ,
  PERS_ID_MODIFICATION 		NUMBER
);

ALTER TABLE GRH_PECHE.SERVICE ADD CONSTRAINT PK_SERVICE PRIMARY KEY(ID_SERVICE) USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.SERVICE ADD CONSTRAINT FK_SER_DEMANDE FOREIGN KEY (ID_DEMANDE) REFERENCES GRH_PECHE.DEMANDE (ID_DEMANDE) DEFERRABLE INITIALLY DEFERRED;
ALTER TABLE GRH_PECHE.SERVICE ADD CONSTRAINT FK_SER_INDIVIDU_ULR FOREIGN KEY (NO_INDIVIDU) REFERENCES GRHUM.INDIVIDU_ULR (NO_INDIVIDU);
ALTER TABLE GRH_PECHE.SERVICE ADD CONSTRAINT FK_SER_ENSEIGNANT_GENERIQUE FOREIGN KEY (ID_ENSEIGNANT_GENERIQUE) REFERENCES GRH_PECHE.ENSEIGNANT_GENERIQUE (ID_ENSEIGNANT_GENERIQUE);
ALTER TABLE GRH_PECHE.SERVICE ADD CONSTRAINT FK_SER_PERSONNE_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE GRH_PECHE.SERVICE ADD CONSTRAINT FK_SER_PERSONNE_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE GRH_PECHE.SERVICE ADD CONSTRAINT CHK_SER_TEM_EG CHECK (TEM_ENS_GENERIQUE IN ('O', 'N') );
ALTER TABLE GRH_PECHE.SERVICE ADD CONSTRAINT CHK_SER_TEM_VALIDE CHECK (TEM_VALIDE IN ('O', 'N') );
-- Un des 2 identifiants (NO_INDIVIDU, ID_ENSEIGNANT_GENERIQUE) doit être renseigné au plus, mais également un des deux doit être renseigné au moins.
ALTER TABLE GRH_PECHE.SERVICE ADD CONSTRAINT INDIVIDU_EG_NULLS CHECK (NO_INDIVIDU IS NOT NULL OR ID_ENSEIGNANT_GENERIQUE IS NOT NULL);
ALTER TABLE GRH_PECHE.SERVICE ADD CONSTRAINT INDIVIDU_EG_NOT_NULLS CHECK (NO_INDIVIDU IS NULL OR ID_ENSEIGNANT_GENERIQUE IS NULL);

CREATE INDEX GRH_PECHE.IDX_SER_ID_DEMANDE ON GRH_PECHE.SERVICE(ID_DEMANDE) TABLESPACE GRH_INDX;
CREATE INDEX GRH_PECHE.IDX_SER_NO_INDIVIDU ON GRH_PECHE.SERVICE(NO_INDIVIDU) TABLESPACE GRH_INDX;
CREATE INDEX GRH_PECHE.IDX_SER_ID_EG ON GRH_PECHE.SERVICE(ID_ENSEIGNANT_GENERIQUE) TABLESPACE GRH_INDX;
CREATE INDEX GRH_PECHE.IDX_SER_ANNEE ON GRH_PECHE.SERVICE(ANNEE) TABLESPACE GRH_INDX;

CREATE SEQUENCE GRH_PECHE.SERVICE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRH_PECHE.SERVICE IS 'Fiche de service d''un intervenant';
COMMENT ON COLUMN GRH_PECHE.SERVICE.ID_SERVICE IS 'Clef primaire de la table SERVICE';
COMMENT ON COLUMN GRH_PECHE.SERVICE.ID_DEMANDE IS 'Référence à la demande sur le circuit de validation (cf. GRH_PECHE.DEMANDE.ID_DEMANDE)';
COMMENT ON COLUMN GRH_PECHE.SERVICE.NO_INDIVIDU IS 'Intervenant concerné (cf. GRHUM.INDIVIDU_ULR.NO_INDIVIDU)';
COMMENT ON COLUMN GRH_PECHE.SERVICE.ID_ENSEIGNANT_GENERIQUE IS 'Intervenant générique concerné (cf. GRH_PECHE.ENSEIGNANT_GENERIQUE.ID_ENSEIGNANT_GENERIQUE)';
COMMENT ON COLUMN GRH_PECHE.SERVICE.TEM_ENS_GENERIQUE IS 'L''affectation concerne un intervenant générique? (O:oui, N:non) ';
COMMENT ON COLUMN GRH_PECHE.SERVICE.TEM_VALIDE IS 'L''enregistrement est-il valide? (O:oui, N:non) ';
COMMENT ON COLUMN GRH_PECHE.SERVICE.COMMENTAIRE IS 'Commentaire sur la fiche de service';
COMMENT ON COLUMN GRH_PECHE.SERVICE.D_COMMENTAIRE IS 'Date de création du commentaire';
COMMENT ON COLUMN GRH_PECHE.SERVICE.ANNEE IS 'Année universitaire considérée';
COMMENT ON COLUMN GRH_PECHE.SERVICE.D_CREATION IS 'Date de création de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.SERVICE.D_MODIFICATION IS 'Date de modification de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.SERVICE.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.SERVICE.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';


--
-- SERVICE_DETAIL
--
CREATE TABLE GRH_PECHE.SERVICE_DETAIL
(
  ID_SERVICE_DETAIL	NUMBER	NOT NULL ,
  ID_AP			NUMBER ,
  ID_REH  		NUMBER ,
  ID_SERVICE		NUMBER	NOT NULL,	
  HEURES_PREVUES 	NUMBER	DEFAULT 0 NOT NULL ,
  HEURES_REALISEES	NUMBER	DEFAULT 0 NOT NULL ,
  COMMENTAIRE 		VARCHAR2(1024) ,
  D_COMMENTAIRE  	DATE ,
  TEM_PAYE 		VARCHAR2(1) DEFAULT 'N' NOT NULL ,
  TEM_REPART_CROISEE 	VARCHAR2(1),
  D_CREATION 		DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION 	DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION  	NUMBER NOT NULL ,
  PERS_ID_MODIFICATION 	NUMBER
);

ALTER TABLE GRH_PECHE.SERVICE_DETAIL ADD CONSTRAINT PK_SERVICE_DETAIL PRIMARY KEY(ID_SERVICE_DETAIL) USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.SERVICE_DETAIL ADD CONSTRAINT FK_SD_AP FOREIGN KEY (ID_AP) REFERENCES SCO_SCOLARITE.AP (ID_AP);
ALTER TABLE GRH_PECHE.SERVICE_DETAIL ADD CONSTRAINT FK_SD_REH FOREIGN KEY (ID_REH) REFERENCES GRH_PECHE.REH (ID_REH);
ALTER TABLE GRH_PECHE.SERVICE_DETAIL ADD CONSTRAINT FK_SD_SERVICE FOREIGN KEY (ID_SERVICE) REFERENCES GRH_PECHE.SERVICE (ID_SERVICE);
ALTER TABLE GRH_PECHE.SERVICE_DETAIL ADD CONSTRAINT FK_SD_PERSONNE_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE GRH_PECHE.SERVICE_DETAIL ADD CONSTRAINT FK_SD_PERSONNE_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE GRH_PECHE.SERVICE_DETAIL ADD CONSTRAINT CHK_SD_TEM_PAYE CHECK (TEM_PAYE IN ('O', 'N') );
ALTER TABLE GRH_PECHE.SERVICE_DETAIL ADD CONSTRAINT CHK_SD_TEM_REPART_CROISEE CHECK (TEM_REPART_CROISEE IN ('A', 'R', 'E') );
-- Un des 2 identifiants (ID_AP, ID_REH) doit être renseigné au plus, mais également un des deux doit être renseigné au moins.
ALTER TABLE GRH_PECHE.SERVICE_DETAIL ADD CONSTRAINT AP_REH_NULLS CHECK (ID_AP IS NOT NULL OR ID_REH IS NOT NULL);
ALTER TABLE GRH_PECHE.SERVICE_DETAIL ADD CONSTRAINT AP_REH_NOT_NULLS CHECK (ID_AP IS NULL OR ID_REH IS NULL);

CREATE INDEX GRH_PECHE.IDX_SD_ID_AP ON GRH_PECHE.SERVICE_DETAIL(ID_AP) TABLESPACE GRH_INDX;
CREATE INDEX GRH_PECHE.IDX_SD_ID_REH ON GRH_PECHE.SERVICE_DETAIL(ID_REH) TABLESPACE GRH_INDX;
CREATE INDEX GRH_PECHE.IDX_SD_ID_SERVICE ON GRH_PECHE.SERVICE_DETAIL(ID_SERVICE) TABLESPACE GRH_INDX;

CREATE SEQUENCE GRH_PECHE.SERVICE_DETAIL_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRH_PECHE.SERVICE_DETAIL IS 'Détail de la fiche de service d''un intervenant';
COMMENT ON COLUMN GRH_PECHE.SERVICE_DETAIL.ID_SERVICE_DETAIL IS 'Clef primaire de la table SERVICE_DETAIL';
COMMENT ON COLUMN GRH_PECHE.SERVICE_DETAIL.ID_AP IS 'Référence à un AP présent dans l''offre de formation où intervient l''enseignant (cf. SCO_SCOLARITE.AP.ID)';
COMMENT ON COLUMN GRH_PECHE.SERVICE_DETAIL.ID_REH IS 'Référence à une activité REH dans laquelle intervient l''enseignant (cf. GRH_PECHE.REH.ID_REH)';
COMMENT ON COLUMN GRH_PECHE.SERVICE_DETAIL.ID_SERVICE IS 'Référence à la fiche de service de l''intervenant (cf. GRH_PECHE.SERVICE.ID_SERVICE)';
COMMENT ON COLUMN GRH_PECHE.SERVICE_DETAIL.HEURES_PREVUES IS 'Heures prévues dans le service de l''intervenant';
COMMENT ON COLUMN GRH_PECHE.SERVICE_DETAIL.HEURES_REALISEES IS 'Heures réalisées dans le service de l''intervenant';
COMMENT ON COLUMN GRH_PECHE.SERVICE_DETAIL.COMMENTAIRE IS 'Commentaire sur le détail de la fiche de service';
COMMENT ON COLUMN GRH_PECHE.SERVICE_DETAIL.D_COMMENTAIRE IS 'Date de création du commentaire';
COMMENT ON COLUMN GRH_PECHE.SERVICE_DETAIL.TEM_PAYE IS 'Intervenant payé (O:oui, N:non) ';
COMMENT ON COLUMN GRH_PECHE.SERVICE_DETAIL.TEM_REPART_CROISEE IS 'Répartition croisée: (A:accepté, R:refusé, E:en attente, null:pas de répartition croisée)';
COMMENT ON COLUMN GRH_PECHE.SERVICE_DETAIL.D_CREATION IS 'Date de création de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.SERVICE_DETAIL.D_MODIFICATION IS 'Date de modification de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.SERVICE_DETAIL.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.SERVICE_DETAIL.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';


--
-- PARAM_POP_HETD
--
CREATE TABLE GRH_PECHE.PARAM_POP_HETD
(
  ID_PARAM_POP_HETD	NUMBER NOT NULL ,
  C_TYPE_CONTRAT_TRAV 	VARCHAR2(2) ,
  C_CORPS 		VARCHAR2(4) ,
  ID_TYPE_AP  	NUMBER(2) NOT NULL ,
  NUMERATEUR_SERVICE	NUMBER NOT NULL,
  DENOMINATEUR_SERVICE	NUMBER DEFAULT 1 NOT NULL, 
  NUMERATEUR_HCOMP	NUMBER ,
  DENOMINATEUR_HCOMP	NUMBER , 
  D_DEBUT 		DATE DEFAULT SYSDATE NOT NULL,
  D_FIN  		DATE ,
  D_CREATION 		DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION 	DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION  	NUMBER NOT NULL ,
  PERS_ID_MODIFICATION 	NUMBER  
);

ALTER TABLE GRH_PECHE.PARAM_POP_HETD ADD CONSTRAINT PK_PARAM_POP_HETD PRIMARY KEY(ID_PARAM_POP_HETD) USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.PARAM_POP_HETD ADD CONSTRAINT FK_PPH_TYPE_CONTRAT_TRAV FOREIGN KEY (C_TYPE_CONTRAT_TRAV) REFERENCES GRHUM.TYPE_CONTRAT_TRAVAIL (C_TYPE_CONTRAT_TRAV);
ALTER TABLE GRH_PECHE.PARAM_POP_HETD ADD CONSTRAINT FK_PPH_CORPS FOREIGN KEY (C_CORPS) REFERENCES GRHUM.CORPS (C_CORPS);
ALTER TABLE GRH_PECHE.PARAM_POP_HETD ADD CONSTRAINT FK_PPH_TYPE_AP FOREIGN KEY (ID_TYPE_AP) REFERENCES SCO_SCOLARITE.TYPE_AP (ID_TYPE_AP);
ALTER TABLE GRH_PECHE.PARAM_POP_HETD ADD CONSTRAINT FK_PPH_PERSONNE_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE GRH_PECHE.PARAM_POP_HETD ADD CONSTRAINT FK_PPH_PERSONNE_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
-- Un des 2 identifiants (C_TYPE_CONTRAT_TRAV, C_CORPS) doit être renseigné au plus, mais également un des deux doit être renseigné au moins.
ALTER TABLE GRH_PECHE.PARAM_POP_HETD ADD CONSTRAINT PPH_TCT_CORPS_NULLS CHECK (C_TYPE_CONTRAT_TRAV IS NOT NULL OR C_CORPS IS NOT NULL);
ALTER TABLE GRH_PECHE.PARAM_POP_HETD ADD CONSTRAINT PPH_TCT_CORPS_NOT_NULLS CHECK (C_TYPE_CONTRAT_TRAV IS NULL OR C_CORPS IS NULL);

CREATE INDEX GRH_PECHE.IDX_PPH_C_TYPE_CONTRAT_TRAV ON GRH_PECHE.PARAM_POP_HETD(C_TYPE_CONTRAT_TRAV) TABLESPACE GRH_INDX;
CREATE INDEX GRH_PECHE.IDX_PPH_C_CORPS ON GRH_PECHE.PARAM_POP_HETD(C_CORPS) TABLESPACE GRH_INDX;
CREATE INDEX GRH_PECHE.IDX_PPH_TYPE_AP ON GRH_PECHE.PARAM_POP_HETD(ID_TYPE_AP) TABLESPACE GRH_INDX;

CREATE SEQUENCE GRH_PECHE.PARAM_POP_HETD_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRH_PECHE.PARAM_POP_HETD IS 'Table qui définit les heures en équivalent TD des AP(CM, TD,...) en fonction de la population';    
COMMENT ON COLUMN GRH_PECHE.PARAM_POP_HETD.ID_PARAM_POP_HETD IS 'Clef primaire de la table PARAM_POP_HETD';
COMMENT ON COLUMN GRH_PECHE.PARAM_POP_HETD.C_TYPE_CONTRAT_TRAV IS 'Type de population concernée parmi les contractuels(cf. GRHUM.TYPE_CONTRAT_TRAVAIL.C_TYPE_CONTRAT_TRAV)';
COMMENT ON COLUMN GRH_PECHE.PARAM_POP_HETD.C_CORPS IS 'Type de population concernée parmi les titulaires (cf. GRHUM.CORPS.C_CORPS)';
COMMENT ON COLUMN GRH_PECHE.PARAM_POP_HETD.ID_TYPE_AP IS 'Type du code de l''AP (cf. SCO_SCOLARITE.TYPE_AP.ID)';
COMMENT ON COLUMN GRH_PECHE.PARAM_POP_HETD.NUMERATEUR_SERVICE IS 'Numérateur du coefficient pour le calcul de l''AP dans le service';
COMMENT ON COLUMN GRH_PECHE.PARAM_POP_HETD.DENOMINATEUR_SERVICE IS 'Dénominateur du coefficient pour le calcul de l''AP dans le service';
COMMENT ON COLUMN GRH_PECHE.PARAM_POP_HETD.NUMERATEUR_HCOMP IS 'Numérateur du coefficient pour le calcul de l''AP en dehors du service dû';
COMMENT ON COLUMN GRH_PECHE.PARAM_POP_HETD.DENOMINATEUR_HCOMP IS 'Dénominateur du coefficient pour le calcul de l''AP en dehors du service dû';
COMMENT ON COLUMN GRH_PECHE.PARAM_POP_HETD.D_DEBUT IS 'Date du début d''application de l''équivalence';
COMMENT ON COLUMN GRH_PECHE.PARAM_POP_HETD.D_FIN IS 'Date de fin d''application de l''équivalence';
COMMENT ON COLUMN GRH_PECHE.PARAM_POP_HETD.D_CREATION IS 'Date de création de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.PARAM_POP_HETD.D_MODIFICATION IS 'Date de modification de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.PARAM_POP_HETD.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.PARAM_POP_HETD.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';

--
-- REPART_ENSEIGNANT
--
CREATE TABLE GRH_PECHE.REPART_ENSEIGNANT
(
  ID_REPART_ENSEIGNANT	NUMBER NOT NULL ,
  ID_SERVICE_DETAIL	NUMBER	NOT NULL ,
  COMPOSANTE_REFERENTE  VARCHAR2(10) NOT NULL ,
  REPARTITEUR_DEMANDEUR	NUMBER NOT NULL ,
  D_CREATION 		DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION 	DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION  	NUMBER NOT NULL ,
  PERS_ID_MODIFICATION 	NUMBER 
);

ALTER TABLE GRH_PECHE.REPART_ENSEIGNANT ADD CONSTRAINT PK_REPART_ENSEIGNANT PRIMARY KEY(ID_REPART_ENSEIGNANT) USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.REPART_ENSEIGNANT ADD CONSTRAINT FK_RE_SERVICE_DETAIL FOREIGN KEY (ID_SERVICE_DETAIL) REFERENCES GRH_PECHE.SERVICE_DETAIL (ID_SERVICE_DETAIL);
ALTER TABLE GRH_PECHE.REPART_ENSEIGNANT ADD CONSTRAINT FK_RE_COMPOSANTE_REFERENTE FOREIGN KEY (COMPOSANTE_REFERENTE) REFERENCES GRHUM.STRUCTURE_ULR (C_STRUCTURE);
ALTER TABLE GRH_PECHE.REPART_ENSEIGNANT ADD CONSTRAINT FK_RE_REPARTITEUR_DEMANDEUR FOREIGN KEY (REPARTITEUR_DEMANDEUR) REFERENCES GRHUM.INDIVIDU_ULR (NO_INDIVIDU);
ALTER TABLE GRH_PECHE.REPART_ENSEIGNANT ADD CONSTRAINT FK_RE_PERS_ID_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE GRH_PECHE.REPART_ENSEIGNANT ADD CONSTRAINT FK_RE_PERS_ID_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);

CREATE INDEX GRH_PECHE.IDX_RE_ID_SERVICE_DETAIL ON GRH_PECHE.REPART_ENSEIGNANT(ID_SERVICE_DETAIL) TABLESPACE GRH_INDX;
CREATE INDEX GRH_PECHE.IDX_RE_COMPOSANTE_REFERENTE ON GRH_PECHE.REPART_ENSEIGNANT(COMPOSANTE_REFERENTE) TABLESPACE GRH_INDX;
CREATE INDEX GRH_PECHE.IDX_RE_REPARTITEUR_DEMANDEUR ON GRH_PECHE.REPART_ENSEIGNANT(REPARTITEUR_DEMANDEUR) TABLESPACE GRH_INDX;

CREATE SEQUENCE GRH_PECHE.REPART_ENSEIGNANT_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRH_PECHE.REPART_ENSEIGNANT IS 'Table où sont listés le répartiteur référent d''un enseignant et un autre répartiteur qui veut affecter des heures à cet enseignant';    
COMMENT ON COLUMN GRH_PECHE.REPART_ENSEIGNANT.ID_REPART_ENSEIGNANT IS 'Clef primaire de la table REPART_ENSEIGNANT';
COMMENT ON COLUMN GRH_PECHE.REPART_ENSEIGNANT.ID_SERVICE_DETAIL IS 'Référence au détail du service de l''enseignant concerné (cf. GRH_PECHE.SERVICE_DETAIL.ID_SERVICE_DETAIL)';
COMMENT ON COLUMN GRH_PECHE.REPART_ENSEIGNANT.COMPOSANTE_REFERENTE IS 'Référence à la composante référente de l''enseignant (cf. GRHUM.STRUCTURE_ULR.C_STRUCTURE)';
COMMENT ON COLUMN GRH_PECHE.REPART_ENSEIGNANT.REPARTITEUR_DEMANDEUR IS 'Référence au répartiteur demandeur d''une autre composante (cf. GRHUM.INDIVIDU_ULR.NO_INDIVIDU)';
COMMENT ON COLUMN GRH_PECHE.REPART_ENSEIGNANT.D_CREATION IS 'Date de création de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.REPART_ENSEIGNANT.D_MODIFICATION IS 'Date de modification de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.REPART_ENSEIGNANT.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.REPART_ENSEIGNANT.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';


--
-- FICHE_VOEUX
--
CREATE TABLE GRH_PECHE.FICHE_VOEUX
(
  ID_FICHE_VOEUX	NUMBER	NOT NULL ,
  ID_DEMANDE		NUMBER NOT NULL,
  NO_INDIVIDU    	NUMBER(8, 0) NOT NULL ,
  COMMENTAIRE 		VARCHAR2(1024) ,
  D_COMMENTAIRE  	DATE DEFAULT SYSDATE ,
  TEM_VALIDE		VARCHAR2(1) DEFAULT 'O' NOT NULL ,
  ANNEE 		NUMBER(4) NOT NULL,
  D_CREATION 		DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION 	DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION  	NUMBER NOT NULL ,
  PERS_ID_MODIFICATION 	NUMBER 
);

ALTER TABLE GRH_PECHE.FICHE_VOEUX ADD CONSTRAINT PK_FICHE_VOEUX PRIMARY KEY(ID_FICHE_VOEUX)USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.FICHE_VOEUX ADD CONSTRAINT FK_FV_DEMANDE FOREIGN KEY (ID_DEMANDE) REFERENCES GRH_PECHE.DEMANDE (ID_DEMANDE) DEFERRABLE INITIALLY DEFERRED;
ALTER TABLE GRH_PECHE.FICHE_VOEUX ADD CONSTRAINT FK_FV_INDIVIDU FOREIGN KEY (NO_INDIVIDU) REFERENCES GRHUM.INDIVIDU_ULR (NO_INDIVIDU);
ALTER TABLE GRH_PECHE.FICHE_VOEUX ADD CONSTRAINT FK_FV_PERSONNE_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE GRH_PECHE.FICHE_VOEUX ADD CONSTRAINT FK_FV_PERSONNE_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE GRH_PECHE.FICHE_VOEUX ADD CONSTRAINT CHK_FV_TEM_VALIDE CHECK (TEM_VALIDE IN ('O', 'N'));

CREATE INDEX GRH_PECHE.IDX_FV_ID_DEMANDE ON GRH_PECHE.FICHE_VOEUX(ID_DEMANDE) TABLESPACE GRH_INDX;
CREATE INDEX GRH_PECHE.IDX_FV_NO_INDIVIDU ON GRH_PECHE.FICHE_VOEUX(NO_INDIVIDU) TABLESPACE GRH_INDX;

CREATE SEQUENCE GRH_PECHE.FICHE_VOEUX_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRH_PECHE.FICHE_VOEUX IS 'Fiche de voeux d''un enseignant';
COMMENT ON COLUMN GRH_PECHE.FICHE_VOEUX.ID_FICHE_VOEUX IS 'Clef primaire de la table FICHE_VOEUX';
COMMENT ON COLUMN GRH_PECHE.FICHE_VOEUX.ID_DEMANDE IS 'Référence à la demande sur le circuit de validation (cf. GRH_PECHE.DEMANDE.ID_DEMANDE)';
COMMENT ON COLUMN GRH_PECHE.FICHE_VOEUX.NO_INDIVIDU IS 'Enseignant concerné (cf. GRHUM.INDIVIDU_ULR.NO_INDIVIDU)';
COMMENT ON COLUMN GRH_PECHE.FICHE_VOEUX.COMMENTAIRE IS 'Commentaire sur la fiche de voeux';
COMMENT ON COLUMN GRH_PECHE.FICHE_VOEUX.D_COMMENTAIRE IS 'Date de création du commentaire';
COMMENT ON COLUMN GRH_PECHE.FICHE_VOEUX.TEM_VALIDE IS 'L''enregistrement est-il valide? (O:oui, N:non) ';
COMMENT ON COLUMN GRH_PECHE.FICHE_VOEUX.ANNEE IS 'Année universitaire considérée';  
COMMENT ON COLUMN GRH_PECHE.FICHE_VOEUX.D_CREATION IS 'Date de création de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.FICHE_VOEUX.D_MODIFICATION IS 'Date de modification de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.FICHE_VOEUX.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.FICHE_VOEUX.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';


--
-- FICHE_VOEUX_DETAIL
--
CREATE TABLE GRH_PECHE.FICHE_VOEUX_DETAIL
(
  ID_FV_DETAIL			NUMBER	NOT NULL,
  ID_FICHE_VOEUX		NUMBER	NOT NULL,
  ID_AP				NUMBER,
  ETABLISSEMENT_EXTERNE		VARCHAR2(1024),
  UE_ETABLISSEMENT_EXTERNE	VARCHAR2(128),
  HEURES_SOUHAITEES 		NUMBER	DEFAULT 0 NOT NULL,
  COMMENTAIRE 			VARCHAR2(1024),
  D_COMMENTAIRE  		DATE DEFAULT SYSDATE ,
  D_CREATION 			DATE DEFAULT SYSDATE NOT NULL,
  D_MODIFICATION 		DATE DEFAULT SYSDATE NOT NULL,
  PERS_ID_CREATION  		NUMBER NOT NULL,
  PERS_ID_MODIFICATION 		NUMBER 
);

ALTER TABLE GRH_PECHE.FICHE_VOEUX_DETAIL ADD CONSTRAINT PK_FICHE_VOEUX_DETAIL PRIMARY KEY(ID_FV_DETAIL) USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.FICHE_VOEUX_DETAIL ADD CONSTRAINT FK_FVD_FICHE_VOEUX FOREIGN KEY (ID_FICHE_VOEUX) REFERENCES GRH_PECHE.FICHE_VOEUX (ID_FICHE_VOEUX);
ALTER TABLE GRH_PECHE.FICHE_VOEUX_DETAIL ADD CONSTRAINT FK_FVD_AP FOREIGN KEY (ID_AP) REFERENCES SCO_SCOLARITE.AP (ID_AP);
ALTER TABLE GRH_PECHE.FICHE_VOEUX_DETAIL ADD CONSTRAINT FK_FVD_PERSONNE_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE GRH_PECHE.FICHE_VOEUX_DETAIL ADD CONSTRAINT FK_FVD_PERSONNE_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);


CREATE INDEX GRH_PECHE.IDX_FVD_ID_FICHE_VOEUX ON GRH_PECHE.FICHE_VOEUX_DETAIL(ID_FICHE_VOEUX) TABLESPACE GRH_INDX;
CREATE INDEX GRH_PECHE.IDX_FVD_ID_AP ON GRH_PECHE.FICHE_VOEUX_DETAIL(ID_AP) TABLESPACE GRH_INDX;

CREATE SEQUENCE GRH_PECHE.FICHE_VOEUX_DETAIL_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRH_PECHE.FICHE_VOEUX_DETAIL IS 'Détail de la fiche de voeux d''un enseignant';
COMMENT ON COLUMN GRH_PECHE.FICHE_VOEUX_DETAIL.ID_FV_DETAIL IS 'Clef primaire de la table FICHE_VOEUX_DETAIL';
COMMENT ON COLUMN GRH_PECHE.FICHE_VOEUX_DETAIL.ID_FICHE_VOEUX IS 'Référence à la fiche de voeux de l''enseignant (cf. GRH_PECHE.FICHE_VOEUX.ID_FICHE_VOEUX)';
COMMENT ON COLUMN GRH_PECHE.FICHE_VOEUX_DETAIL.ID_AP IS 'Référence à un AP présent dans l''offre de formation où intervient l''enseignant (cf. SCO_SCOLARITE.AP.ID)';
COMMENT ON COLUMN GRH_PECHE.FICHE_VOEUX_DETAIL.ETABLISSEMENT_EXTERNE IS 'Nom de l''établissement si l''enseignement n''est pas dans celui d''origine';
COMMENT ON COLUMN GRH_PECHE.FICHE_VOEUX_DETAIL.UE_ETABLISSEMENT_EXTERNE IS 'UE renseigné uniquement dans le cadre d''un autre établissement si connue';
COMMENT ON COLUMN GRH_PECHE.FICHE_VOEUX_DETAIL.HEURES_SOUHAITEES IS 'Nombre d''heures souhaitées par l''enseignant';
COMMENT ON COLUMN GRH_PECHE.FICHE_VOEUX_DETAIL.COMMENTAIRE IS 'Commentaire sur le détail de la fiche de voeux';
COMMENT ON COLUMN GRH_PECHE.FICHE_VOEUX_DETAIL.D_COMMENTAIRE IS 'Date de création du commentaire';
COMMENT ON COLUMN GRH_PECHE.FICHE_VOEUX_DETAIL.D_CREATION IS 'Date de création de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.FICHE_VOEUX_DETAIL.D_MODIFICATION IS 'Date de modification de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.FICHE_VOEUX_DETAIL.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.FICHE_VOEUX_DETAIL.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';






























--
--  V_PERSONNEL_ACTUEL_ENS
--
CREATE OR REPLACE VIEW GRH_PECHE.V_PERSONNEL_ACTUEL_ENS (NO_DOSSIER_PERS, TEM_TITULAIRE)
AS
  --Enseignant titulaire 
  SELECT
    c.no_dossier_pers, 'O'
  FROM
    MANGUE.element_carriere c,
    GRHUM.corps co,
    GRHUM.type_population tp
  WHERE
    (
      c.d_effet_element <= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'), 'dd/mm/YYYY')
    AND
      (
        c.d_fin_element  IS NULL
      OR c.d_fin_element >= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'), 'dd/mm/YYYY')
      )
    )
  AND c.tem_valide    = 'O'
  AND c.c_corps       = co.c_corps
  AND co.c_type_corps = tp.c_type_population
  AND
    (
      tp.tem_enseignant = 'O'
    OR tp.tem_2degre    = 'O'
    OR tp.tem_ens_sup   = 'O'
    )
  UNION
  -- inclusion des contrats enseignant au niveau réglementaire
  SELECT
    c.no_dossier_pers, 'N'
  FROM
    MANGUE.contrat c,
    GRHUM.type_contrat_travail tct
  WHERE
    (
      c.d_deb_contrat_trav <= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'),
      'dd/mm/YYYY')
    AND
      (
        c.d_fin_contrat_trav                  IS NULL
      OR ADD_MONTHS (c.d_fin_contrat_trav, 1) >= TO_DATE (TO_CHAR (SYSDATE,
        'dd/mm/YYYY'), 'dd/mm/YYYY')
      )
    )
  AND tct.droit_conges_contrat         = 'O'
  AND c.tem_annulation                 = 'N'
  AND tct.tem_enseignant               = 'O'
  AND c.c_type_contrat_trav            = tct.c_type_contrat_trav
  AND tct.tem_remuneration_accessoire != 'O'
  AND tct.tem_titulaire               != 'O'
  AND tct.tem_invite_associe          != 'O'
  UNION
  -- inclusion des contrats non enseignant typés enseignant
  SELECT
    c.no_dossier_pers, 'N'
  FROM
    MANGUE.CONTRAT_VACATAIRES v,
    MANGUE.CONTRAT c ,
    GRHUM.TYPE_CONTRAT_TRAVAIL tct
  WHERE
    c.no_seq_contrat  = v.no_seq_contrat
  AND v.tem_enseignant='O'
  AND
    (
      c.d_deb_contrat_trav   <= SYSDATE
    AND ( c.d_fin_contrat_trav IS NULL
          OR c.d_fin_contrat_trav  >= SYSDATE
        )
    )
  AND c.c_type_contrat_trav            = tct.c_type_contrat_trav
  AND c.tem_annulation                 = 'N'
  AND tct.TEM_REMUNERATION_ACCESSOIRE != 'O'
  AND tct.TEM_TITULAIRE               != 'O'
  UNION
  -- inclusion des contrats non enseignant typés par le
  -- typepopulation enseignant pour des fonctionnaires
  SELECT
    no_dossier_pers, 'N'
  FROM
    MANGUE.contrat c,
    GRHUM.type_contrat_travail tct,
    MANGUE.contrat_avenant ca,
    GRHUM.grade g,
    GRHUM.corps c,
    GRHUM.type_population tp
  WHERE
    (
      c.d_deb_contrat_trav <= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'), 'dd/mm/YYYY')
    AND
      (
        c.d_fin_contrat_trav IS NULL
      OR ADD_MONTHS (c.d_fin_contrat_trav, 1) >= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'), 'dd/mm/YYYY')
      )
    )
  AND tct.droit_conges_contrat         = 'O'
  AND c.tem_annulation                 = 'N'
  AND tct.tem_enseignant               = 'O'
  AND c.c_type_contrat_trav            = tct.c_type_contrat_trav
  AND tct.tem_remuneration_accessoire != 'O'
  AND tct.tem_titulaire               != 'O'
  AND c.no_seq_contrat                 = ca.no_seq_contrat
  AND ca.c_grade                       = g.c_grade
  AND g.c_corps                        = c.c_corps
  AND c.c_type_corps                   = tp.c_type_population
  AND tp.tem_enseignant                = 'O'
  AND ca.tem_annulation                = 'N'
  AND ca.d_deb_contrat_av             <= TO_DATE (TO_CHAR (SYSDATE,
    'dd/mm/YYYY'), 'dd/mm/YYYY')
  AND
    (
      ca.d_fin_contrat_av IS NULL
    OR ADD_MONTHS (ca.d_fin_contrat_av, 1) >= TO_DATE (TO_CHAR (SYSDATE,
      'dd/mm/YYYY'), 'dd/mm/YYYY')
    )
  UNION
  -- Prise en compte des Professeurs émérites
  SELECT
    no_dossier_pers, 'N'
  FROM
    MANGUE.emeritat E
  WHERE
    E.D_DEB_EMERITAT <= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'), 'dd/mm/YYYY')
  AND
    (
      E.D_FIN_EMERITAT  IS NULL
      OR E.D_FIN_EMERITAT >= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'),
      'dd/mm/YYYY')
    );

----------------------------V20130718.110350__DDL_Creation_vue_table.sql----------------------------
--
-- Patch DDL de GRH_PECHE du 06/06/2013 à exécuter depuis le user GRH_PECHE
--
-- Rem : fichier encodé UTF-8 (Idem 2013060602_SQL_GRH_PECHE_V0.3.0.0_DDL.sql)

--
--
-- Fichier : 2/3
-- Type : DDL
-- Schema : GRH_PECHE
-- Numero de version : 0.3.0.0
-- Date de publication : 06/06/2013 
-- Auteur(s) : Cocktail
-- Licence : CeCILL version 2
--
--

--
--  V_PERSONNEL_ACTUEL_ENS
--
CREATE OR REPLACE VIEW GRH_PECHE.V_PERSONNEL_ACTUEL_ENS (NO_DOSSIER_PERS, TEM_STATUTAIRE, TEM_TITULAIRE)
AS
  --Enseignant statutaire titulaire 
  SELECT
    c.no_dossier_pers, 'O', 'O'
  FROM
    MANGUE.element_carriere c,
    GRHUM.corps co,
    GRHUM.type_population tp
  WHERE
    (
      c.d_effet_element <= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'), 'dd/mm/YYYY')
    AND
      (
        c.d_fin_element  IS NULL
      OR c.d_fin_element >= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'), 'dd/mm/YYYY')
      )
    )
  AND c.tem_valide    = 'O'
  AND
    (
      tp.tem_enseignant = 'O'
    OR tp.tem_2degre    = 'O'
    OR tp.tem_ens_sup   = 'O'
    )
  AND c.c_corps       = co.c_corps
  AND co.c_type_corps = tp.c_type_population
  UNION
  -- inclusion des contrats enseignant au niveau réglementaire
  SELECT
    c.no_dossier_pers, 'O', 'N'
  FROM
    MANGUE.contrat c,
    GRHUM.type_contrat_travail tct
  WHERE
    (
      c.d_deb_contrat_trav <= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'),
      'dd/mm/YYYY')
    AND
      (
        c.d_fin_contrat_trav                  IS NULL
      OR ADD_MONTHS (c.d_fin_contrat_trav, 1) >= TO_DATE (TO_CHAR (SYSDATE,
        'dd/mm/YYYY'), 'dd/mm/YYYY')
      )
    )
  AND tct.droit_conges_contrat         = 'O'
  AND c.tem_annulation                 = 'N'
  AND tct.tem_enseignant               = 'O'
  AND tct.tem_remuneration_accessoire != 'O'
  AND tct.tem_titulaire               != 'O'
  AND tct.tem_invite_associe          != 'O'
  AND c.c_type_contrat_trav            = tct.c_type_contrat_trav
  UNION
  -- inclusion des contrats vacataires typés enseignant
  SELECT
    c.no_dossier_pers, 'N', 'N'
  FROM
    MANGUE.CONTRAT_VACATAIRES v,
    MANGUE.CONTRAT c ,
    GRHUM.TYPE_CONTRAT_TRAVAIL tct
  WHERE
     v.tem_enseignant='O'
  AND
    (
      c.d_deb_contrat_trav   <= SYSDATE
    AND ( c.d_fin_contrat_trav IS NULL
          OR c.d_fin_contrat_trav  >= SYSDATE
        )
    )
  AND c.tem_annulation                 = 'N'
  AND tct.TEM_REMUNERATION_ACCESSOIRE != 'O'
  AND tct.TEM_TITULAIRE               != 'O'
  AND c.no_seq_contrat  = v.no_seq_contrat
  AND c.c_type_contrat_trav            = tct.c_type_contrat_trav
  UNION
  -- Prise en compte des Professeurs émérites
  SELECT
    no_dossier_pers, 'N', 'N'
  FROM
    MANGUE.emeritat E
  WHERE
    E.D_DEB_EMERITAT <= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'), 'dd/mm/YYYY')
  AND
    (
      E.D_FIN_EMERITAT  IS NULL
      OR E.D_FIN_EMERITAT >= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'),
      'dd/mm/YYYY')
    );

--
-- Calcul HCOMP
--
    
alter table GRH_PECHE.PARAM_POP_HETD drop constraint PPH_TCT_CORPS_NULLS;

alter table GRH_PECHE.REPART_METHODE_CORPS drop constraint PK_REPART_METHODE_CORPS;
alter table GRH_PECHE.REPART_METHODE_CORPS add (ID_REPART_METHODE_CORPS number not null);
alter table GRH_PECHE.REPART_METHODE_CORPS add constraint PK_REPART_METHODE_CORPS primary key (ID_REPART_METHODE_CORPS) using index tablespace GRH_INDX;
alter table GRH_PECHE.REPART_METHODE_CORPS add constraint UK_REPART_METHODE_CORPS_CORPS unique (C_CORPS);
create sequence GRH_PECHE.REPART_METHODE_CORPS_SEQ start with 1 increment by 1 minvalue 1 nocycle noorder;

-- UE FLOTTANTES
-- REPART_UEF_ETABLISSEMENT
--
CREATE TABLE GRH_PECHE.REPART_UEF_ETABLISSEMENT
(
  ID_REPART_UEF_ETAB	NUMBER NOT NULL ,
  ID_UE			NUMBER 	NOT NULL ,
  ETABLISSEMENT_EXTERNE	VARCHAR2(1024) NOT NULL ,
  D_CREATION 		DATE DEFAULT SYSDATE NOT NULL ,
  D_MODIFICATION 	DATE DEFAULT SYSDATE NOT NULL ,
  PERS_ID_CREATION  	NUMBER NOT NULL ,
  PERS_ID_MODIFICATION 	NUMBER 
);

ALTER TABLE GRH_PECHE.REPART_UEF_ETABLISSEMENT ADD CONSTRAINT PK_REPART_UEF_ETABLISSEMENT PRIMARY KEY(ID_REPART_UEF_ETAB) USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.REPART_UEF_ETABLISSEMENT ADD CONSTRAINT FK_RUE_UE FOREIGN KEY (ID_UE) 
REFERENCES SCO_SCOLARITE.UE (ID_UE) DEFERRABLE INITIALLY DEFERRED;
ALTER TABLE GRH_PECHE.REPART_UEF_ETABLISSEMENT ADD CONSTRAINT FK_RUE_PERSONNE_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE GRH_PECHE.REPART_UEF_ETABLISSEMENT ADD CONSTRAINT FK_RUE_PERSONNE_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);

CREATE INDEX GRH_PECHE.IDX_RUE_ID_UE ON GRH_PECHE.REPART_UEF_ETABLISSEMENT(ID_UE) TABLESPACE GRH_INDX;

CREATE SEQUENCE GRH_PECHE.REPART_UEF_ETABLISSEMENT_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRH_PECHE.REPART_UEF_ETABLISSEMENT IS 'Table de répartition des UE flottantes (taguées PECHE) et d''un établissement d''enseignement externe';    
COMMENT ON COLUMN GRH_PECHE.REPART_UEF_ETABLISSEMENT.ID_REPART_UEF_ETAB IS 'Clef primaire de la table REPART_UEF_ETABLISSEMENT';
COMMENT ON COLUMN GRH_PECHE.REPART_UEF_ETABLISSEMENT.ID_UE IS 'Référence à une UE flottante présente dans l''offre de formation où intervient l''enseignant (cf. SCO_SCOLARITE.UE.ID)';
COMMENT ON COLUMN GRH_PECHE.REPART_UEF_ETABLISSEMENT.ETABLISSEMENT_EXTERNE IS 'Etablissement externe où se déroulera l''enseignement';
COMMENT ON COLUMN GRH_PECHE.REPART_UEF_ETABLISSEMENT.D_CREATION IS 'Date de création de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.REPART_UEF_ETABLISSEMENT.D_MODIFICATION IS 'Date de modification de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.REPART_UEF_ETABLISSEMENT.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.REPART_UEF_ETABLISSEMENT.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';


---------------------V20130718.110624__DDL_Ajout_colonnes_mise_en_paiement.sql----------------------
-- ----------------
-- Mise en paiement
-- ----------------

-- Ajout de colonnes dans SERVICE
ALTER TABLE GRH_PECHE.SERVICE
  ADD (
    HEURES_A_PAYER NUMBER,
    HEURES_A_REPORTER_SOUHAITEES NUMBER,
    HEURES_A_REPORTER_ATTRIBUEES NUMBER,
    HEURES_GRATUITES NUMBER,
    HEURES_PAYEES NUMBER
  );

COMMENT ON COLUMN GRH_PECHE.SERVICE.HEURES_A_PAYER IS 'Heures à payer (parmi les HComp et pour les statutaires)';
COMMENT ON COLUMN GRH_PECHE.SERVICE.HEURES_A_REPORTER_SOUHAITEES IS 'Heures que l''enseignant souhaite reporter pour l''année N+1 (parmi les HComp et pour les statutaires)';
COMMENT ON COLUMN GRH_PECHE.SERVICE.HEURES_A_REPORTER_ATTRIBUEES IS 'Heures effectivement reportées pour l''année N+1 (parmi les HComp et pour les statutaires)';
COMMENT ON COLUMN GRH_PECHE.SERVICE.HEURES_GRATUITES IS 'Heures qui ne seront pas payées (parmi les HComp et pour les statutaires)';
COMMENT ON COLUMN GRH_PECHE.SERVICE.HEURES_PAYEES IS 'Heures qui ont été payées (parmi les HComp et pour les statutaires)';

-- Ajout de colonnes dans SERVICE_DETAIL
ALTER TABLE GRH_PECHE.SERVICE_DETAIL
  ADD (
    HEURES_A_PAYER NUMBER,
    HEURES_PAYEES NUMBER
  );

COMMENT ON COLUMN GRH_PECHE.SERVICE_DETAIL.HEURES_A_PAYER IS 'Heures à payer (parmi les heures réalisées et pour les vacataires)';
COMMENT ON COLUMN GRH_PECHE.SERVICE_DETAIL.HEURES_PAYEES IS 'Heures qui ont été payées (parmi les heures réalisées et pour les vacataires)';


----------------------V20130718.164812__DDL_Ajout_tables_mise_en_paiement.sql-----------------------
-- ----------------
-- Mise en paiement
-- ----------------

--DROP TABLE GRH_PECHE.MISE_EN_PAIEMENT;
--DROP SEQUENCE GRH_PECHE.MISE_EN_PAIEMENT_SEQ;
--DROP TABLE GRH_PECHE.ARRETE;
--DROP SEQUENCE GRH_PECHE.ARRETE_SEQ;

-- Table "Arrêté"

CREATE TABLE GRH_PECHE.ARRETE (
	ID_ARRETE NUMBER NOT NULL,
	NUMERO_ARRETE NUMBER NOT NULL,
	MOIS_PAIEMENT NUMBER(2) NOT NULL,
	ANNEE_PAIEMENT NUMBER(4) NOT NULL,
	PAYE CHAR(1) DEFAULT 'N' NOT NULL,
	D_CREATION DATE DEFAULT SYSDATE NOT NULL,
	D_MODIFICATION DATE DEFAULT SYSDATE NOT NULL,
	PERS_ID_CREATION NUMBER NOT NULL,
	PERS_ID_MODIFICATION NUMBER NOT NULL
);

ALTER TABLE GRH_PECHE.ARRETE ADD CONSTRAINT PK_ARRETE PRIMARY KEY(ID_ARRETE) USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.ARRETE ADD CONSTRAINT UK_ARRETE UNIQUE (NUMERO_ARRETE) USING INDEX TABLESPACE GRH_INDX;

ALTER TABLE GRH_PECHE.ARRETE ADD CONSTRAINT FK_ARRETE_PERS_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE(PERS_ID);
ALTER TABLE GRH_PECHE.ARRETE ADD CONSTRAINT FK_ARRETE_PERS_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE(PERS_ID);
ALTER TABLE GRH_PECHE.ARRETE ADD CONSTRAINT CHK_ARRETE_PAYE CHECK (PAYE IN ('O', 'N'));

CREATE SEQUENCE GRH_PECHE.ARRETE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRH_PECHE.ARRETE IS 'Table contenant les arrêtés de mise en paiement';
COMMENT ON COLUMN GRH_PECHE.ARRETE.ID_ARRETE IS 'Clef primaire de la table';
COMMENT ON COLUMN GRH_PECHE.ARRETE.NUMERO_ARRETE IS 'Numéro d''arrêté';
COMMENT ON COLUMN GRH_PECHE.ARRETE.MOIS_PAIEMENT IS 'Mois de paiement de cet arrêté';
COMMENT ON COLUMN GRH_PECHE.ARRETE.ANNEE_PAIEMENT IS 'Année de paiement de cet arrêté';
COMMENT ON COLUMN GRH_PECHE.ARRETE.PAYE IS 'Est-ce qu ecet arrêté est payé (O/N) ? Si oui, il n''est plus du tout modifiable (ni les mises en paiement associées).';
COMMENT ON COLUMN GRH_PECHE.ARRETE.D_CREATION IS 'Date de création de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.ARRETE.D_MODIFICATION IS 'Date de modification de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.ARRETE.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.ARRETE.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';

-- Table "Mise en paiement"

CREATE TABLE GRH_PECHE.MISE_EN_PAIEMENT (
	ID_MISE_EN_PAIEMENT NUMBER NOT NULL,
	ID_SERVICE NUMBER NOT NULL,
	ID_SERVICE_DETAIL NUMBER NULL,
	ID_ARRETE NUMBER NULL,
	HEURES_A_PAYEES NUMBER NOT NULL,
	HEURES_PAYEES NUMBER NULL,
	D_CREATION DATE DEFAULT SYSDATE NOT NULL,
	D_MODIFICATION DATE DEFAULT SYSDATE NOT NULL,
	PERS_ID_CREATION NUMBER NOT NULL,
	PERS_ID_MODIFICATION NUMBER NOT NULL
);

ALTER TABLE GRH_PECHE.MISE_EN_PAIEMENT ADD CONSTRAINT PK_MISE_EN_PAIEMENT PRIMARY KEY(ID_MISE_EN_PAIEMENT) USING INDEX TABLESPACE GRH_INDX;

ALTER TABLE GRH_PECHE.MISE_EN_PAIEMENT ADD CONSTRAINT FK_MEP_SERVICE FOREIGN KEY (ID_SERVICE) REFERENCES GRH_PECHE.SERVICE(ID_SERVICE);
ALTER TABLE GRH_PECHE.MISE_EN_PAIEMENT ADD CONSTRAINT FK_MEP_SERVICE_DETAIL FOREIGN KEY (ID_SERVICE_DETAIL) REFERENCES GRH_PECHE.SERVICE_DETAIL(ID_SERVICE_DETAIL);
ALTER TABLE GRH_PECHE.MISE_EN_PAIEMENT ADD CONSTRAINT FK_MEP_ARRETE FOREIGN KEY (ID_ARRETE) REFERENCES GRH_PECHE.ARRETE(ID_ARRETE);
ALTER TABLE GRH_PECHE.MISE_EN_PAIEMENT ADD CONSTRAINT FK_MEP_PERS_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE(PERS_ID);
ALTER TABLE GRH_PECHE.MISE_EN_PAIEMENT ADD CONSTRAINT FK_MEP_PERS_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE(PERS_ID);

CREATE SEQUENCE GRH_PECHE.MISE_EN_PAIEMENT_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRH_PECHE.MISE_EN_PAIEMENT IS 'Table contenant l''historique des heures mise en paiement (à payer ou payées)';
COMMENT ON COLUMN GRH_PECHE.MISE_EN_PAIEMENT.ID_MISE_EN_PAIEMENT IS 'Clef primaire de la table';
COMMENT ON COLUMN GRH_PECHE.MISE_EN_PAIEMENT.ID_SERVICE IS 'Référence à une fiche de service';
COMMENT ON COLUMN GRH_PECHE.MISE_EN_PAIEMENT.ID_SERVICE_DETAIL IS 'Référence à un détail fiche de service (doit être un détail de la fiche de service référencée par ID_SERVICE)';
COMMENT ON COLUMN GRH_PECHE.MISE_EN_PAIEMENT.ID_ARRETE IS 'Référence vers un arrêté (null si les heures ne sont pas encore payées)';
COMMENT ON COLUMN GRH_PECHE.MISE_EN_PAIEMENT.HEURES_A_PAYEES IS 'Heures à payer';
COMMENT ON COLUMN GRH_PECHE.MISE_EN_PAIEMENT.HEURES_PAYEES IS 'Heures payées';
COMMENT ON COLUMN GRH_PECHE.MISE_EN_PAIEMENT.D_CREATION IS 'Date de création de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.MISE_EN_PAIEMENT.D_MODIFICATION IS 'Date de modification de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.MISE_EN_PAIEMENT.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.MISE_EN_PAIEMENT.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';

--------------------V20130729.143342__DDL_Ajout_table_flux_mise_en_paiement.sql---------------------
-- ------------------------
-- Flux de mise en paiement
-- ------------------------

--DROP TABLE GRH_PECHE.FLUX_MISE_EN_PAIEMENT;
--DROP SEQUENCE GRH_PECHE.FLUX_MISE_EN_PAIEMENT_SEQ;

-- Table "Flux de mise en paiement"

CREATE TABLE GRH_PECHE.FLUX_MISE_EN_PAIEMENT (
	ID_FLUX_MISE_EN_PAIEMENT NUMBER NOT NULL,
	ID_ARRETE NUMBER NOT NULL,
	ID_SERVICE NUMBER NOT NULL,
	NO_INSEE CHAR(13) NULL,
	CLE_INSEE NUMBER(2) NULL,
	NOM VARCHAR2(80) NOT NULL,
	PRENOM VARCHAR2(40) NOT NULL,
	NPC CHAR(2) NULL,
	HEURES_PAYEES NUMBER NOT NULL,
	TAUX_NON_CHARGE NUMBER NOT NULL,
	BRUT_PAYE NUMBER NOT NULL,
	D_CREATION DATE DEFAULT SYSDATE NOT NULL,
	D_MODIFICATION DATE DEFAULT SYSDATE NOT NULL,
	PERS_ID_CREATION NUMBER NOT NULL,
	PERS_ID_MODIFICATION NUMBER NOT NULL
);

ALTER TABLE GRH_PECHE.FLUX_MISE_EN_PAIEMENT ADD CONSTRAINT PK_FLUX_MISE_EN_PAIEMENT PRIMARY KEY(ID_FLUX_MISE_EN_PAIEMENT) USING INDEX TABLESPACE GRH_INDX;

ALTER TABLE GRH_PECHE.FLUX_MISE_EN_PAIEMENT ADD CONSTRAINT FK_FMEP_ARRETE FOREIGN KEY (ID_ARRETE) REFERENCES GRH_PECHE.ARRETE(ID_ARRETE);
ALTER TABLE GRH_PECHE.FLUX_MISE_EN_PAIEMENT ADD CONSTRAINT FK_FMEP_SERVICE FOREIGN KEY (ID_SERVICE) REFERENCES GRH_PECHE.SERVICE(ID_SERVICE);
ALTER TABLE GRH_PECHE.FLUX_MISE_EN_PAIEMENT ADD CONSTRAINT FK_FMEP_PERS_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE(PERS_ID);
ALTER TABLE GRH_PECHE.FLUX_MISE_EN_PAIEMENT ADD CONSTRAINT FK_FMEP_PERS_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE(PERS_ID);

CREATE INDEX GRH_PECHE.IDX_FMEP_NO_INSEE ON GRH_PECHE.FLUX_MISE_EN_PAIEMENT(NO_INSEE) TABLESPACE GRH_INDX;
CREATE INDEX GRH_PECHE.IDX_FMEP_NOM_PRENOM ON GRH_PECHE.FLUX_MISE_EN_PAIEMENT(NOM, PRENOM) TABLESPACE GRH_INDX;

CREATE SEQUENCE GRH_PECHE.FLUX_MISE_EN_PAIEMENT_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRH_PECHE.FLUX_MISE_EN_PAIEMENT IS 'Table contenant l''historique des heures mise en paiement (à payer ou payées)';
COMMENT ON COLUMN GRH_PECHE.FLUX_MISE_EN_PAIEMENT.ID_FLUX_MISE_EN_PAIEMENT IS 'Clef primaire de la table';
COMMENT ON COLUMN GRH_PECHE.FLUX_MISE_EN_PAIEMENT.ID_ARRETE IS 'Référence vers un arrêté';
COMMENT ON COLUMN GRH_PECHE.FLUX_MISE_EN_PAIEMENT.ID_SERVICE IS 'Référence à une fiche de service';
COMMENT ON COLUMN GRH_PECHE.FLUX_MISE_EN_PAIEMENT.NO_INSEE IS 'Numéro INSEE de l''individu';
COMMENT ON COLUMN GRH_PECHE.FLUX_MISE_EN_PAIEMENT.CLE_INSEE IS 'Clef INSEE de l''individu';
COMMENT ON COLUMN GRH_PECHE.FLUX_MISE_EN_PAIEMENT.NOM IS 'Nom de la personne physique (peut contenir des caractères accentués)';
COMMENT ON COLUMN GRH_PECHE.FLUX_MISE_EN_PAIEMENT.PRENOM IS 'Prénom de la personne physique (peut contenir des caractères accentués)';
COMMENT ON COLUMN GRH_PECHE.FLUX_MISE_EN_PAIEMENT.NPC IS 'Numéro de Prise en Charge du dossier de l''agent pour les indemnités';
COMMENT ON COLUMN GRH_PECHE.FLUX_MISE_EN_PAIEMENT.HEURES_PAYEES IS 'Le nombre d''heures payées';
COMMENT ON COLUMN GRH_PECHE.FLUX_MISE_EN_PAIEMENT.TAUX_NON_CHARGE IS 'Le taux horaire non chargé';
COMMENT ON COLUMN GRH_PECHE.FLUX_MISE_EN_PAIEMENT.BRUT_PAYE IS 'Le montant brut payé';
COMMENT ON COLUMN GRH_PECHE.FLUX_MISE_EN_PAIEMENT.D_CREATION IS 'Date de création de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.FLUX_MISE_EN_PAIEMENT.D_MODIFICATION IS 'Date de modification de l''enregistrement.';
COMMENT ON COLUMN GRH_PECHE.FLUX_MISE_EN_PAIEMENT.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.FLUX_MISE_EN_PAIEMENT.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';

-------------------------V20130731.170451__DDL_Ajout_table_taux_horaire.sql-------------------------
-- -------------------------------
-- Mise en paiement - Taux horaire
-- -------------------------------

--DROP TABLE GRH_PECHE.TAUX_HORAIRE;
--DROP SEQUENCE GRH_PECHE.TAUX_HORAIRE_SEQ;
--INSERT INTO GRH_PECHE.TAUX_HORAIRE VALUES (GRH_PECHE.TAUX_HORAIRE_SEQ.NEXTVAL, 40.91, 42.96, 58.09, '01/01/2013', NULL, '01/08/2013', '01/08/2013', 72, 72);

CREATE TABLE GRH_PECHE.TAUX_HORAIRE (
	ID_TAUX_HORAIRE NUMBER NOT NULL,
	TAUX_BRUT NUMBER NOT NULL,
	TAUX_CHARGE_FONCTIONNAIRE NUMBER NOT NULL,
	TAUX_CHARGE_NON_FONCTIONNAIRE NUMBER NOT NULL,
	D_DEBUT DATE DEFAULT SYSDATE NOT NULL,
	D_FIN DATE NULL,
	D_CREATION DATE DEFAULT SYSDATE NOT NULL,
	D_MODIFICATION DATE DEFAULT SYSDATE NOT NULL,
	PERS_ID_CREATION NUMBER NOT NULL,
	PERS_ID_MODIFICATION NUMBER NOT NULL
);

ALTER TABLE GRH_PECHE.TAUX_HORAIRE ADD CONSTRAINT PK_TAUX_HORAIRE PRIMARY KEY(ID_TAUX_HORAIRE) USING INDEX TABLESPACE GRH_INDX;
ALTER TABLE GRH_PECHE.TAUX_HORAIRE ADD CONSTRAINT FK_TH_PERSONNE_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE(PERS_ID);
ALTER TABLE GRH_PECHE.TAUX_HORAIRE ADD CONSTRAINT FK_TH_PERSONNE_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE(PERS_ID);

CREATE INDEX GRH_PECHE.IDX_TH_D_FIN_D_DEBUT ON GRH_PECHE.TAUX_HORAIRE(D_FIN, D_DEBUT) TABLESPACE GRH_INDX;

CREATE SEQUENCE GRH_PECHE.TAUX_HORAIRE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRH_PECHE.TAUX_HORAIRE IS 'Table des taux horaires appliqués pour les paiements des intervenants';    
COMMENT ON COLUMN GRH_PECHE.TAUX_HORAIRE.ID_TAUX_HORAIRE IS 'Clef primaire de la table';
COMMENT ON COLUMN GRH_PECHE.TAUX_HORAIRE.TAUX_BRUT IS 'Taux horaire brut appliqué à toutes populations confondus';
COMMENT ON COLUMN GRH_PECHE.TAUX_HORAIRE.TAUX_CHARGE_FONCTIONNAIRE IS 'Taux horaire chargé pour les fonctionnaires uniquement';
COMMENT ON COLUMN GRH_PECHE.TAUX_HORAIRE.TAUX_CHARGE_NON_FONCTIONNAIRE IS 'Taux horaire chargé pour les non fonctionnaires uniquement';
COMMENT ON COLUMN GRH_PECHE.TAUX_HORAIRE.D_DEBUT IS 'Date du début d''application du taux horaire';
COMMENT ON COLUMN GRH_PECHE.TAUX_HORAIRE.D_FIN IS 'Date de fin d''application du taux horaire';
COMMENT ON COLUMN GRH_PECHE.TAUX_HORAIRE.D_CREATION IS 'Date de création de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.TAUX_HORAIRE.D_MODIFICATION IS 'Date de modification de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.TAUX_HORAIRE.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN GRH_PECHE.TAUX_HORAIRE.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';

----------------------V20130823.113132__DDL_Index_dans_tablespace_grh_indx.sql----------------------
-- Recréation de l'index sur le tablespace INDX

ALTER TABLE GRH_PECHE.REPART_METHODE_CORPS DROP CONSTRAINT UK_REPART_METHODE_CORPS_CORPS;
ALTER TABLE GRH_PECHE.REPART_METHODE_CORPS  ADD CONSTRAINT UK_REPART_METHODE_CORPS_CORPS UNIQUE (C_CORPS) USING INDEX TABLESPACE GRH_INDX;

-------------------V20130828.143444__DDL_Maj_sequence_methodes_calculs_hcomp.sql--------------------
-- --------------------------------------------------------------------------------------
-- Mise à jour de la séquence de la table "Méthodes de calcul des heures complémentaires"
-- --------------------------------------------------------------------------------------

DROP SEQUENCE GRH_PECHE.METHODES_CALCUL_HCOMP_SEQ;
CREATE SEQUENCE GRH_PECHE.METHODES_CALCUL_HCOMP_SEQ START WITH 5;
-----------------------V20130904.174850__DDL_Modification_vue_enseignant.sql------------------------
-- -----------------------------------------------------------------
-- Prise en compte de la date de fin anticipée pour les vacataires
-- -----------------------------------------------------------------


CREATE OR REPLACE FORCE VIEW GRH_PECHE.V_PERSONNEL_ACTUEL_ENS (
  NO_DOSSIER_PERS, TEM_STATUTAIRE, TEM_TITULAIRE)
AS
  SELECT
    c.no_dossier_pers,
    'O',
    'O'
  FROM
    MANGUE.element_carriere c,
    GRHUM.corps co,
    GRHUM.type_population tp
  WHERE
    (
      c.d_effet_element <= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'),
      'dd/mm/YYYY')
    AND
      (
        c.d_fin_element  IS NULL
      OR c.d_fin_element >= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'),
        'dd/mm/YYYY')
      )
    )
  AND c.tem_valide = 'O'
  AND
    (
      tp.tem_enseignant = 'O'
    OR tp.tem_2degre    = 'O'
    OR tp.tem_ens_sup   = 'O'
    )
  AND c.c_corps       = co.c_corps
  AND co.c_type_corps = tp.c_type_population
  UNION
  -- inclusion des contrats enseignant au niveau réglementaire
  SELECT
    c.no_dossier_pers,
    'O',
    'N'
  FROM
    MANGUE.contrat c,
    GRHUM.type_contrat_travail tct
  WHERE
    (
      c.d_deb_contrat_trav <= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'),
      'dd/mm/YYYY')
    AND
      (
        c.d_fin_contrat_trav                  IS NULL
      OR ADD_MONTHS (c.d_fin_contrat_trav, 1) >= TO_DATE (TO_CHAR (SYSDATE,
        'dd/mm/YYYY'), 'dd/mm/YYYY')
      )
    )
  AND tct.droit_conges_contrat         = 'O'
  AND c.tem_annulation                 = 'N'
  AND tct.tem_enseignant               = 'O'
  AND tct.tem_remuneration_accessoire != 'O'
  AND tct.tem_titulaire               != 'O'
  AND tct.tem_invite_associe          != 'O'
  AND c.c_type_contrat_trav            = tct.c_type_contrat_trav
  UNION
  -- inclusion des contrats vacataires typés enseignant
  SELECT
    c.no_dossier_pers,
    'N',
    'N'
  FROM
    MANGUE.CONTRAT_VACATAIRES v,
    MANGUE.CONTRAT c ,
    GRHUM.TYPE_CONTRAT_TRAVAIL tct
  WHERE
    v.tem_enseignant='O'
  AND
    (
      c.d_deb_contrat_trav <= SYSDATE
    AND
      (
        c.d_fin_anticipee   IS NOT NULL
      AND c.d_fin_anticipee >= SYSDATE
      )
    OR
      (
        c.d_fin_anticipee IS NULL
      AND
        (
          c.d_fin_contrat_trav  IS NULL
        OR c.d_fin_contrat_trav >= SYSDATE
        )
      )
    )
  AND c.tem_annulation                 = 'N'
  AND tct.TEM_REMUNERATION_ACCESSOIRE != 'O'
  AND tct.TEM_TITULAIRE               != 'O'
  AND c.no_seq_contrat                 = v.no_seq_contrat
  AND c.c_type_contrat_trav            = tct.c_type_contrat_trav
  UNION
  -- Prise en compte des Professeurs émérites
  SELECT
    no_dossier_pers,
    'N',
    'N'
  FROM
    MANGUE.emeritat E
  WHERE
    E.D_DEB_EMERITAT <= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'), 'dd/mm/YYYY')
  AND
    (
      E.D_FIN_EMERITAT  IS NULL
    OR E.D_FIN_EMERITAT >= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'),
      'dd/mm/YYYY')
    );

-----------------------V20130905.172659__DDL_Modification_vue_enseignant.sql------------------------
-- -------------------------------------------------------------------
-- Ajout filtre pour remonter que les enseignants statutaires actifs
-- -------------------------------------------------------------------


CREATE OR REPLACE FORCE VIEW GRH_PECHE.V_PERSONNEL_ACTUEL_ENS (
  NO_DOSSIER_PERS, TEM_STATUTAIRE, TEM_TITULAIRE)
AS
  SELECT
     c.no_dossier_pers,
    'O',
    'O'
  FROM
    MANGUE.carriere c,
    MANGUE.element_carriere ec,
    MANGUE.changement_position cp,
    GRHUM.corps co,
    GRHUM.type_population tp
  WHERE
    (
      ec.d_effet_element <= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'),
      'dd/mm/YYYY')
    AND
      (
        ec.d_fin_element  IS NULL
      OR ec.d_fin_element >= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'),
        'dd/mm/YYYY')
      )
    )
  AND ec.tem_valide = 'O'
  AND
    (
      tp.tem_enseignant = 'O'
    OR tp.tem_2degre    = 'O'
    OR tp.tem_ens_sup   = 'O'
    )
    
  AND cp.c_position = 'ACTI'
  AND cp.tem_valide = 'O'
  AND c.no_seq_carriere = cp.carriere_accueil
  AND c.no_dossier_pers = cp.no_dossier_pers
  AND c.no_seq_carriere = ec.no_seq_carriere
  AND c.no_dossier_pers = ec.no_dossier_pers  
  AND ec.c_corps       = co.c_corps
  AND co.c_type_corps = tp.c_type_population
  UNION
  -- inclusion des contrats enseignant au niveau réglementaire
  SELECT
    c.no_dossier_pers,
    'O',
    'N'
  FROM
    MANGUE.contrat c,
    GRHUM.type_contrat_travail tct
  WHERE
    (
      c.d_deb_contrat_trav <= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'),
      'dd/mm/YYYY')
    AND
      (
        c.d_fin_contrat_trav                  IS NULL
      OR ADD_MONTHS (c.d_fin_contrat_trav, 1) >= TO_DATE (TO_CHAR (SYSDATE,
        'dd/mm/YYYY'), 'dd/mm/YYYY')
      )
    )
  AND tct.droit_conges_contrat         = 'O'
  AND c.tem_annulation                 = 'N'
  AND tct.tem_enseignant               = 'O'
  AND tct.tem_remuneration_accessoire != 'O'
  AND tct.tem_titulaire               != 'O'
  AND tct.tem_invite_associe          != 'O'
  AND c.c_type_contrat_trav            = tct.c_type_contrat_trav
  UNION
  -- inclusion des contrats vacataires typés enseignant
  SELECT
    c.no_dossier_pers,
    'N',
    'N'
  FROM
    MANGUE.CONTRAT_VACATAIRES v,
    MANGUE.CONTRAT c ,
    GRHUM.TYPE_CONTRAT_TRAVAIL tct
  WHERE
    v.tem_enseignant='O'
  AND
    (
      c.d_deb_contrat_trav <= SYSDATE
    AND
      (
        c.d_fin_anticipee   IS NOT NULL
      AND c.d_fin_anticipee >= SYSDATE
      )
    OR
      (
        c.d_fin_anticipee IS NULL
      AND
        (
          c.d_fin_contrat_trav  IS NULL
        OR c.d_fin_contrat_trav >= SYSDATE
        )
      )
    )
  AND c.tem_annulation                 = 'N'
  AND tct.TEM_REMUNERATION_ACCESSOIRE != 'O'
  AND tct.TEM_TITULAIRE               != 'O'
  AND c.no_seq_contrat                 = v.no_seq_contrat
  AND c.c_type_contrat_trav            = tct.c_type_contrat_trav
  UNION
  -- Prise en compte des Professeurs émérites
  SELECT
    no_dossier_pers,
    'N',
    'N'
  FROM
    MANGUE.emeritat E
  WHERE
    E.D_DEB_EMERITAT <= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'), 'dd/mm/YYYY')
  AND
    (
      E.D_FIN_EMERITAT  IS NULL
    OR E.D_FIN_EMERITAT >= TO_DATE (TO_CHAR (SYSDATE, 'dd/mm/YYYY'),
      'dd/mm/YYYY')
    );



